;##################################################################
; DLLAPP
;##################################################################

/*
 2007 Edgar Hansen
This example is free for all uses except in conjunction with a GPL application.
Any use or distribution for use with a GPL application will be considered a violation
of my copyright.
*/

#Include "IContextMenu.Inc"

DATA SECTION
	hInstance		DD		0
	m_pDataObj		DD		0
	m_cRef			DD		0
	m_HDROP			DD		0

	// Easy key changes
	szKeyName		DB		"\IContextMenu",0
	szKey1			DB		"exefile\shellex\ContextMenuHandlers",0

	// Note if no second key is needed delete the appropriate lines in DllRegisterServer and DllUnregisterServer
	szKey2			DB		"dllfile\shellex\ContextMenuHandlers",0


;	szShellExtensionID		DB	"ShellExtExample",0
	szCLSID					DB	"CLSID",0

	IID_IUnknown			GUID	GUID_IID_IUnknown
	IID_IClassFactory		GUID	GUID_IID_IClassFactory
	IID_IShellExtInit		GUID	GUID_IID_IShellExtInit
	IID_IContextMenu		GUID	GUID_IID_IContextMenu
	CLSID_ShellExtension	GUID	GUID_CLSID_ShellExtension

	// OBJECTS AND VTABLES

	vtIClassFactory	IClassFactory <>
	vtShellExtension	IShellExtension <>
	vtIContextMenu	IContextMenu <>
	ObjClassFactory	COMObject <offset vtIClassFactory , 0>
	ObjShellExtension	COMObject <offset vtShellExtension, 0>
	ObjContextMenu COMObject <offset vtIContextMenu, 0>

	buffer db 256 dup ?

;##################################################################

CODE SECTION

DllEntryPoint	FRAME hInst, reason, reserved1

	mov eax,[reason]
	.DLLPROCESSATTACH
	cmp eax,DLL_PROCESS_ATTACH
	JNE >.DLLPROCESSDETACH
		mov eax,[hInst]
		mov [hInstance], eax
		JMP >.LOAD
	
	.DLLPROCESSDETACH
	cmp eax,DLL_PROCESS_DETACH
	JNE >.DLLTHREADATTACH
		JMP >.LOAD
	
	.DLLTHREADATTACH
	cmp eax,DLL_THREAD_ATTACH
	JNE >.DLLTHREADDETACH
		JMP >.LOAD
	
	.DLLTHREADDETACH
	cmp eax,DLL_THREAD_DETACH
	JNE >.NOLOAD
		JMP >.LOAD
	
	.NOLOAD
		; The reson was not understood
		; Rather than take a chance we will refuse to load
		xor eax, eax
		ret
	
	.LOAD
		xor eax, eax
		inc eax

	ret
ENDF

//---------------------------------------------------------------------------
// Minimum Export Requirements
//---------------------------------------------------------------------------

DllCanUnloadNow:
	mov eax, S_FALSE
	cmp D[ObjClassFactory.nRefCount],0
	jne >
		mov eax, S_OK
	:
	ret

DllGetClassObject FRAME rclsid, riid, ppvOut

	invoke IsEqualGUID, [rclsid], offset CLSID_ShellExtension
	test eax,eax
	jz >
		invoke ClassFactoryQueryInterface,offset ObjClassFactory,[riid],[ppvOut]
		ret
	:
	mov eax,[ppvOut]
	mov D[eax], NULL
	mov eax, CLASS_E_CLASSNOTAVAILABLE
	ret
ENDF

DllRegisterServer FRAME
	uses ebx
	LOCAL hKey:D
	LOCAL hSubKey:D
	LOCAL szIID[128]:B
	LOCAL szIIDW[256]:B
	LOCAL szCLSID[MAX_PATH]:B
	LOCAL szDllPath[MAX_PATH]:B

	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL
	dec eax
	mov ebx,eax

	// Build our CLSID main key
	invoke lstrcpy,offset szCLSID,"CLSID\"
	invoke lstrcat,offset szCLSID,offset szIID

	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke RegSetValueEx,[hKey],"",0,REG_SZ,"IContextMenu example",20
	invoke RegCloseKey,[hKey]

	invoke lstrcat,offset szCLSID,"\InprocServer32"

	//Open the main key
	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke GetModuleFileName,[hInstance],addr szDllPath,MAX_PATH
	invoke RegSetValue,[hKey],0,REG_SZ,addr szDllPath,eax
	invoke RegSetValueEx,[hKey],"ThreadingModel",0,REG_SZ,"Apartment",9
	invoke RegCloseKey,[hKey]

	invoke lstrcpy,offset buffer,offset szKey1
	invoke lstrcat,offset buffer,offset szKeyName

	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset buffer,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke RegSetValue,[hKey],0,REG_SZ,addr szIID,ebx
	invoke RegCloseKey,[hKey]

	// If no second key is needed delete the following lines 
	invoke lstrcpy,offset buffer,offset szKey2
	invoke lstrcat,offset buffer,offset szKeyName

	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset buffer,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >.notregistered
	invoke RegSetValue,[hKey],0,REG_SZ,addr szIID,ebx
	invoke RegCloseKey,[hKey]
	// Delete up to here

	invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0

	mov eax,S_OK
	ret

	.notregistered
	mov eax, -1 
	ret
ENDF

DllUnregisterServer FRAME
	LOCAL hKey:D
	LOCAL hSubKey:D
	LOCAL szIID[128]:B
	LOCAL szIIDW[256]:B
	LOCAL szCLSID[MAX_PATH]:B
	LOCAL szDllPath[MAX_PATH]:B

	invoke RegOpenKey,HKEY_CLASSES_ROOT,offset szKey1,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	// Add 1 to szKeyName in order to skip past the \
	invoke RegDeleteKey,[hKey],offset szKeyName+1
	invoke RegCloseKey,[hKey]
	:

	// If no second key is needed delete the following lines 
	invoke RegOpenKey,HKEY_CLASSES_ROOT,offset szKey2,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	// Add 1 to szKeyName in order to skip past the \
	invoke RegDeleteKey,[hKey],offset szKeyName+1
	invoke RegCloseKey,[hKey]
	:
	// Delete up to here

	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL

	// Build our CLSID main key
	invoke lstrcpy,offset szCLSID,"CLSID\"
	invoke lstrcat,offset szCLSID,offset szIID

	invoke RegOpenKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],"InprocServer32"
	invoke RegCloseKey,[hKey]
	:

	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL
	invoke RegOpenKey,HKEY_CLASSES_ROOT,"CLSID",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],offset szIID
	invoke RegCloseKey,[hKey]
	:

	invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0

	xor eax, eax ; mov eax, S_OK
	ret
ENDF

/*
****************************************************************************************
Standard functions
****************************************************************************************
*/

NewObject FRAME
	LOCAL pNewObject:D
	// Creates a new COM object

	invoke  CoTaskMemAlloc, sizeof COMObject
	mov [pNewObject], eax
	test eax,eax
	jz >
		; we got our memory
		; initialize the new object
		mov edx, [pNewObject]
		mov D[edx+COMObject.lpVtbl], OFFSET vtIContextMenu
		mov D[edx+COMObject.nRefCount], 0
	:
	mov eax, [pNewObject] ; restore our memory pointer
	ret
ENDF

/*
****************************************************************************************
IClassFactory Handler
****************************************************************************************
*/

ClassFactoryQueryInterface FRAME this,riid, ppv

	// Any interface on this object is the object pointer
	invoke IsEqualGUID,[riid],offset IID_IUnknown
	push eax
	invoke IsEqualGUID,[riid],offset IID_IClassFactory
	pop ecx
	or eax,ecx
	jz >.NOINTERFACE
		mov eax,[this]
		mov edx,[ppv]
		mov [edx],eax
		invoke ClassFactoryAddRef, eax
		xor eax,eax
		ret
	.NOINTERFACE
	mov eax,[ppv]
	mov D[eax], NULL
	mov eax,E_NOINTERFACE
	ret
ENDF

ClassFactoryAddRef FRAME this
	inc D[ObjClassFactory.nRefCount]
	mov eax,[ObjClassFactory.nRefCount]
	ret
ENDF

ClassFactoryRelease FRAME this
	dec D[ObjClassFactory.nRefCount]
	mov eax,[ObjClassFactory.nRefCount]
	ret
ENDF

ClassFactoryCreateInstance FRAME this, pUnkOuter, riid, ppvObj
	// Shell extensions typically don't support aggregation (inheritance)

	cmp D[pUnkOuter],0
	je >
		mov eax,[ppvObj]
		mov D[eax],0
		mov eax, CLASS_E_NOAGGREGATION
		ret
	:
	// Create the main shell extension object.  The shell will then call
	// QueryInterface with IID_IShellExtInit--this is how shell extensions are
	// initialized.

;	invoke NewObject
	mov eax, offset ObjShellExtension
	test eax,eax
	jnz >
		mov edx,[ppvObj]
		mov D[edx],0
		mov eax,E_OUTOFMEMORY
		ret
	:

	// Check for E_NOINTERFACE and initialize our pointer
	mov edx,[eax]
	invoke [edx+IShellExtension.IUnknown.QueryInterface],eax,[riid],[ppvObj]
	ret
ENDF

ClassFactoryLockServer FRAME this, fLock
	mov eax, E_FAIL
	ret
ENDF

/*
****************************************************************************************
IShellExtension Handler
****************************************************************************************
*/

ShellExtInitialize FRAME this, pIDFolder, pDataObj, hRegKey
	LOCAL fmte:FORMATETC
	LOCAL medium:STGMEDIUM
	// Initialize can be called more than once

	// Release any existing IDataObject interface
	mov eax,[m_pDataObj]
	test eax,eax
	jz >
		mov edx,[eax]
		invoke [edx+IDataObject.IUnknown.Release],eax
	:

	// Save the pointer to the IDataObject interface
	mov eax,[pDataObj]
	test eax,eax
	jz >
		mov edx,[eax]
		mov [m_pDataObj],eax

		invoke [edx+IDataObject.IUnknown.AddRef], eax

		//// Get the list of files in the CF_HDROP format
		mov D[fmte.cfFormat], CF_HDROP
		mov D[fmte.ptd], NULL
		mov D[fmte.dwAspect], DVASPECT_CONTENT
		mov D[fmte.lindex], -1
		mov D[fmte.tymed], TYMED_HGLOBAL

		CoInvoke(m_pDataObj, IDataObject.GetData, offset fmte, offset medium)

		// Store the handle for later use		
		mov eax,[medium.handle]
		mov [m_HDROP],eax
	:

	mov eax, NOERROR
	ret
ENDF

ShellExtAddRef FRAME this
;	inc d[m_cRef]
	mov eax,[this]
	inc D[eax+COMObject.nRefCount]
	mov eax,[eax+COMObject.nRefCount]
;	mov eax, [m_cRef]
	ret
ENDF

ShellExtRelease FRAME this
	
	mov eax,[this]
	dec D[eax+COMObject.nRefCount]

;	dec D[m_cRef]
	js >.SIGNED
	jnz >
		.SIGNED
		mov D[eax+COMObject.nRefCount],0
;		invoke CoTaskMemFree,[this]
;		mov D[m_cRef], 0
		xor eax,eax
		ret
	:

	mov eax,[eax+COMObject.nRefCount]
;	mov eax, [m_cRef]
	ret
ENDF

ShellExtQueryInterface FRAME this, riid, ppv

	invoke IsEqualGUID, [riid], offset IID_IShellExtInit
	push eax
	invoke IsEqualGUID, [riid], offset IID_IUnknown
	pop ecx
	or eax,ecx
	jz >
		mov eax, [this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:

	invoke IsEqualGUID, [riid], offset IID_IContextMenu
	test eax,eax
	jz >
		invoke NewObject ;CreateContextMenuObject
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:

	mov eax,[ppv]
	mov D[eax], 0
	mov eax,E_NOINTERFACE
	ret
ENDF

/*
****************************************************************************************
IContextMenu Handler
****************************************************************************************
*/

ContextMenuQueryInterface FRAME  this, riid, ppv

	mov eax,[ppv]
	mov D[eax], 0

	invoke IsEqualGUID, [riid], offset IID_IContextMenu
	push eax
	invoke IsEqualGUID, [riid], offset IID_IUnknown
	pop ecx
	or eax,ecx
	jz >
		mov eax, [this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:
	mov eax,E_NOINTERFACE
	ret
ENDF

ContextMenuAddRef FRAME this
	mov eax,[this]
	inc D[eax+COMObject.nRefCount]
	mov eax,[eax+COMObject.nRefCount]
	ret
ENDF

ContextMenuRelease FRAME this
	mov eax,[this]
	dec D[eax+COMObject.nRefCount]
	jnz >
		invoke CoTaskMemFree,[this]
		xor eax,eax
		ret
	:
	mov eax,[eax+COMObject.nRefCount]

	ret
ENDF

ContextMenuInvokeCommand FRAME this,lpcmi
	uses ebx
	//If HIWORD(lpcmi->lpVerb) then we have been called programmatically
	//and lpVerb is a command that should be invoked.  Otherwise, the shell
	//has called us, and LOWORD(lpcmi->lpVerb) is the menu ID the user has
	//selected.  Actually, it's (menu ID - idCmdFirst) from QueryContextMenu().

	mov ebx, [lpcmi]
	mov edx, [ebx+CMINVOKECOMMANDINFOEX.lpVerb]
	shr edx,16
	test edx,edx
	jnz >>.isnotverb
		; this is a menu ID so execute the right sub
		cmp D[ebx+CMINVOKECOMMANDINFOEX.lpVerb], 2
		jne >>
			invoke DragQueryFile,[m_HDROP],0,offset buffer,260
			
			invoke DoMenu, [ebx+CMINVOKECOMMANDINFOEX.hwnd], [ebx+CMINVOKECOMMANDINFOEX.lpDirectory], \
				[ebx+CMINVOKECOMMANDINFOEX.lpVerb], [ebx+CMINVOKECOMMANDINFOEX.lpParameters], [ebx+CMINVOKECOMMANDINFOEX.nShow], \
				offset buffer
			ret
		:
		; The next menu item would go here
	.isnotverb
	mov eax, E_INVALIDARG
	ret
ENDF

ContextMenuGetCommandString FRAME this,idCmd,uFlags,reserved,pszName,cchMax

	cmp D[idCmd],0
	jne >
		invoke lstrcpyn, [pszName], "New menu item number 1", [cchMax]
	:
	mov eax, NOERROR
	RET
ENDF

ContextMenuQueryContextMenu FRAME this, hMenu, indexMenu, idCmdFirst, idCmdLast, uFlags
	uses ebx
	LOCAL idCmd:D
	LOCAL bAppendItems:D

	mov ebx,[indexMenu]
	mov D[bAppendItems],TRUE
	mov eax,[idCmdFirst]
	mov [idCmd],eax

	mov eax, [uFlags]
	and eax, CMF_DEFAULTONLY
	jz >
		mov D[bAppendItems], FALSE
	:

	cmp D[bAppendItems], TRUE
	jne >.noappend
		inc ebx
		inc D[idCmd]
		invoke InsertMenu, [hMenu], ebx, MF_SEPARATOR|MF_BYPOSITION, 0, NULL
		inc ebx
		inc D[idCmd]
		invoke InsertMenu,[hMenu], ebx, MF_STRING|MF_BYPOSITION, [idCmd], "IContextMenu Example"
		inc ebx
		inc D[idCmd]
		invoke InsertMenu, [hMenu], ebx, MF_SEPARATOR|MF_BYPOSITION, 0, NULL
		mov eax,[idCmd]
		sub eax,[idCmdFirst]
		ret

	.noappend
	mov eax, NOERROR
	RET
ENDF

DoMenu FRAME hwnd,lpDirectory,lpVerb,lpParameters,nShow, lpFileName

	invoke MessageBox,0,[lpFileName], "IContextMenu Example",0
	RET
ENDF

MsgBoxNumber FRAME num, title
	pushad
	invoke wsprintfA,offset buffer, "%u", [num]
	add esp,12
	invoke MessageBox, NULL, offset buffer, [title], 0
	popad
	RET
ENDF


